class CloseCashierPdf < Prawn::Document
  attr_accessor :label_width,:price_column_width,:page_width, :page_height, :margin, :price_width, :item_width, :header_font_size, :item_font_size,:item_height,:qty_width,:total_width,:item_description_width,:text_width
  def initialize(printer_settings, shift_sale,shop_details)
    self.page_width = 210
    self.page_height = 7000
    self.margin = 5
    self.price_width = 40
    self.qty_width = 20
    self.total_width = 40
    self.item_width = self.page_width - ((self.price_width + self.qty_width + self.total_width))
    self.item_height = 15
    self.item_description_width = (self.page_width-20) / 2
    self.label_width = 100

    self.text_width = (self.page_width - 80) - self.price_width / 3
    # @item_width = self.page_width.to_i / 2
    # @qty_width = @item_width.to_i / 3
    # @double = @qty_width * 1.3
    # @half_qty = @qty_width / 2
    #setting page margin and width
    super(:margin => [printer_settings.heading_space, self.margin, self.margin, self.margin], :page_size => [self.page_width, self.page_height])

    # font "public/fonts/#{font_name}".to_s + ".ttf".to_s
    # font "public/fonts/Zawgyi-One.ttf"
    # font "public/fonts/padauk.ttf"
    self.header_font_size = 10
    self.item_font_size = 8



    header( shop_details)

    stroke_horizontal_rule

    shift_detail(shift_sale)


    
  end

  def header (shop_details)
    move_down 7
    text "#{shop_details.name}", :left_margin => -10, :size => self.header_font_size,:align => :center
    move_down 5
    text "#{shop_details.address}", :size => self.item_font_size,:align => :center
    # move_down self.item_height
    move_down 5
    text "#{shop_details.phone_no}", :size => self.item_font_size,:align => :center
    move_down 5

    stroke_horizontal_rule
  end

  def shift_detail(shift_sale)
        move_down 7
         y_position = cursor
        bounding_box([0,y_position], :width =>self.label_width, :height => self.item_height) do
            text "Cashier : ", :size => self.item_font_size,:align => :left
        end
        bounding_box([self.label_width,y_position], :width => self.label_width, :height => self.item_height) do
            text "#{ shift_sale.employee.name}" , :size => self.item_font_size,:align => :left
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.label_width, :height => self.item_height) do
            text "Cashier Station : ", :size => self.item_font_size,:align => :left
        end
        bounding_box([self.label_width,y_position], :width => self.label_width, :height => self.item_height) do
            text "#{ shift_sale.cashier_terminal.name}" , :size => self.item_font_size,:align => :left
        end
        
        y_position = cursor
        bounding_box([0,y_position], :width =>self.label_width, :height => self.item_height) do
            text "Opening Float : ", :size => self.item_font_size,:align => :left
        end
        bounding_box([self.label_width,y_position], :width => self.label_width, :height => self.item_height) do
            text "#{ shift_sale.opening_balance}" , :size => self.item_font_size,:align => :left
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.label_width, :height => self.item_height) do
            text "Closing Float : ", :size => self.item_font_size,:align => :left
        end
        bounding_box([self.label_width,y_position], :width => self.label_width, :height => self.item_height) do
            text "#{ shift_sale.closing_balance}" , :size => self.item_font_size,:align => :left
        end


        move_down 10

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Received Amount :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{shift_sale.closing_balance}", :size => self.item_font_size, :align => :right
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Net Sales:", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{shift_sale.nett_sales}", :size => self.item_font_size, :align => :right
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Total Tax :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{shift_sale.total_taxes}", :size => self.item_font_size, :align => :right
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Cash Payment :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{shift_sale.cash_sales}", :size => self.item_font_size, :align => :right
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Credit Payment :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{shift_sale.credit_sales}", :size => self.item_font_size, :align => :right
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Other Payment :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{shift_sale.other_sales}", :size => self.item_font_size, :align => :right
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Total Sale :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{shift_sale.total_revenue}", :size => self.item_font_size, :align => :right
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Discount Amount :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{shift_sale.total_discounts}", :size => self.item_font_size, :align => :right
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Commercial Tax :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{shift_sale.commercial_taxes}", :size => self.item_font_size, :align => :right
        end

         y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Grand Total :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{shift_sale.grand_total}", :size => self.item_font_size, :align => :right
        end

         move_down 5
        stroke_horizontal_rule
        move_down 5
		move_down 5

  end

end

